<?php
namespace Ak\Orm\Repository;

use Ak\Orm\Entity\EntityInterface;

/**
 * Pruža pristup entitetima aplikaciji.
 *
 * @package Ak\Orm\Repository
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/orm
 */
interface RepositoryInterface
{
    /**
     * Traži entitet po ID-u.
     *
     * @param int $id
     *
     * @return EntityInterface|null
     */
    public function find(int $id): ?EntityInterface;

    /**
     * Sprema novi entitet u bazu i vraća ga.
     *
     * @param EntityInterface $entity
     * @return EntityInterface
     */
    public function insert(EntityInterface $entity): EntityInterface;

    /**
     * Ažurira postojeći entitet u bazi.
     *
     * @param EntityInterface $entity
     */
    public function update(EntityInterface $entity): void;

    /**
     * Briše entitet iz baze.
     *
     * @param EntityInterface $entity
     */
    public function delete(EntityInterface $entity): void;
}