<?php
namespace Ak\Orm\Repository;

use Interop\Container\ContainerInterface;
use Laminas\ServiceManager\Factory\AbstractFactoryInterface;

final class RepositoryManagerProxyAbstractFactory implements AbstractFactoryInterface
{
    /**
     * Can the factory create an instance for the service?
     *
     * @param  ContainerInterface $container
     * @param  string $requestedName
     * @return bool
     */
    public function canCreate(ContainerInterface $container, $requestedName)
    {
        /** @var RepositoryManager $repos */
        $repos = $container->get(RepositoryManager::class);
        return $repos->has($requestedName);
    }

    /**
     * Create an object
     *
     * @param  ContainerInterface $container
     * @param  string $requestedName
     * @param  null|array $options
     *
     * @return RepositoryInterface
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        /** @var RepositoryManager $repos */
        $repos = $container->get(RepositoryManager::class);
        return $repos->get($requestedName);
    }
}
